/********************************************************************************
|  CLASS:         TLS2118 - Getting Started with MPLAB C for PIC18
|  PROGRAM:       Lab4.c   
|  DESCRIPTION:   First MPLAB C18 project to test whether everything is working
|  REQUIREMENTS:  TLS2118.lib 
|                              
| 
|  REVISION HISTORY:
|  30 APR 2009    Rob Ostapiuk v1.0
********************************************************************************/
#include <p18cxxx.h>
#include "P18F_LCD.h"
#include <stdlib.h>
#include <timers.h>
#include <adc.h>

// 	BootLoader - N #pragma config  , ] BootLoader |ϥ User  Configuration ]w 

//	#pragma config OSC=INTIO7, WDT=OFF, BOREN = ON, BORV = 1, LVP=OFF, PBADEN=OFF, XINST = OFF, MCLRE = ON

#define	LED1				LATDbits.LATD0
#define	SW2					PORTBbits.RB0
#define	TIMER1_INT_FLAG		PIR1bits.TMR1IF
#define	TIMER1_1ms_VALUE 	65536-(1000*2)+96		//	CPU runs @ 8Mhz , 2MHZ Fcy , 1ms = 1000 us

unsigned char	HH = 0 ;
unsigned char	MM = 0 ; 
unsigned char	SS = 0 ;
unsigned int	Timer1_Acc = 0 ;
unsigned char	FLAG_1ms ;

char			ASCII_Buffer[10] ;

void	HighISR(void) ;
void	Update_ADC(unsigned int) ;


#pragma	interrupt HighISR
void	HighISR(void)
{
	if (TIMER1_INT_FLAG)
	{
		TIMER1_INT_FLAG = 0 ;
		WriteTimer1(TIMER1_1ms_VALUE);
		FLAG_1ms = 1 ;
	}
}
#pragma code

void main(void)
{
	OSCCONbits.IRCF = 0x07 ;		// 	Select INTOSC-8Mhz as clock source
									// 	ToDo : iHվ IRCF 줸ӳ]wu@Wv 
	ADCON1bits.PCFG = 0x0f ;		//	Set all ADC multiplexed pins as digital mode
    OpenLCD();

    putrsLCD((const rom far char*)"Lab4 ADC ");
	LCD_Set_Cursor(1,0) ;
	putrsLCD((const rom far char*)"ADC =      ");

	INTCONbits.GIE = 1 ;
	INTCONbits.PEIE = 1 ;

	LATD = 0x00 ;		// Turn Off all LEDs

		WriteTimer1(TIMER1_1ms_VALUE);
		OpenTimer1(	TIMER_INT_ON & T1_16BIT_RW &\
					T1_SOURCE_INT & T1_PS_1_1 & \
					T1_OSC1EN_OFF & T1_SYNC_EXT_OFF ) ;
		OpenADC( 	ADC_FOSC_16 & ADC_RIGHT_JUST & ADC_4_TAD ,
					ADC_CH0 & ADC_INT_OFF & ADC_REF_VDD_VSS ,
					ADC_1ANA); 
		
    
    while(1)
	{
		if (FLAG_1ms)
		{
			FLAG_1ms = 0 ;
			Timer1_Acc ++ ;
			if ( Timer1_Acc == 100 )	//  C 100mS ഫ AD 
			{
				Timer1_Acc = 0 ;
				SelChanConvADC(ADC_CH0) ;
				while(BusyADC()) ;
				Update_ADC(ReadADC()) ;
			}
		}

	}	
}


void Update_ADC(unsigned int ADC_Value)
{
	LCD_Set_Cursor(1,6);
	putrsLCD((const rom far char*)"     ");						// SOഫ,b Compiler ɷ|@ Warning !!
	LCD_Set_Cursor(1,6);
	itoa(ADC_Value,ASCII_Buffer) ;
	putsLCD(ASCII_Buffer);
}
